Subject: [Rfc-markdown] 1.2.12: use ?anchor= feature for bibxml with stand_alone: false as well

From: Carsten Bormann <[email-masked]>
Date: Fri, 17 May 2019 22:14:51 +0200

I just pushed version 1.2.12 of kramdown-rfc2629 that can use reference anchor renaming for `stand_alone: false` as well.

Update as usual:

	gem update

If you are using `stand_alone: true` as I’d recommend, you can stop reading here.

Grüße, Carsten

.oOo.

Recap:  With stand_alone: true (the setting you will want to use), kramdown-rfc embeds bibxml entries into the xml, so xml2rfc does not have to do any lookup.  This allows kramdown-rfc to freely change the labels (anchors) of those references.  Label replacement is particularly useful for DOI references, as their default labels are unwieldy.

With 1.2.12, a similar feature is now available for documents using `stand_alone: false`, by making use of the server side renaming available for DOI and IANA references (bibxml7 and bibxml8) only.

For stand_alone: false, replacement labels of the form

informative:
  foo: DOI.10.1145_1282427.1282421

now allow you to reference the document as {{foo}}, which will also be the label used in the references section(*).  (That was already possible for `stand_alone: true` before.)   The server-side mechanics needed for this only works for DOI and IANA references, though (no such limitation exists for `stand_alone: true`, where it is becoming popular to do things like

informative:
  OSCORE: I-D.ietf-core-object-security

to change the unwieldy I-D label to the readable reference label OSCORE — as a side effect, it is then a local change to put in the RFC number instead, once that is known:

informative:
  OSCORE: RFCabcd

).

This is a slightly user-visible change, because the functionality now applies in a wider set of cases, but also because of a limitation in the way in which xml2rfc performs reference caching:  You may need to clean out cached references in ~/.cache/xml2rfc if you introduce a replacement label or change it.

By the way, I have not repaired the slight inconsistency that 

informative:
  DOI.10.1145_1282427.1282421:

leads to a label called {{DOI.10.1145_1282427.1282421}} for `stand_alone: true` while the server-supplied label is {{DOI_10.1145_1282427.1282421}} for `stand_alone: false` — fixing that might invalidate too many documents, and people will move to replacement labels on these kinds of references anyway.  If that hurts, fudge it by being specific on the form you want:

informative:
  DOI.10.1145_1282427.1282421: DOI.10.1145_1282427.1282421

(*) RFC 7322 does not say so outright, but it seems the RFC editor prefers upper case for symbolic citation tags, except where the tag includes (parts of) a lower case document name, so you may want to do:

informative:
  FOO: DOI.10.1145_1282427.1282421